<template>
  <div class="container">
    <h4>
      {{poll_question}}
    </h4>
    <div class="progress-item" v-for="(poll,index) in poll_options[0]" v-bind:prop="poll[0]" v-bind:key="index">
        <div class="options-text badge badge-dark text-wrap">
            {{poll[0]}}
        </div>
        <div class="progress"> 
        <div
            class="progress-bar-striped bg-info"
            role="progressbar"
            :style="{width: calculatePercent(poll[1], total_votes)+'%'}"
            :aria-valuenow="calculatePercent(poll[1], total_votes)"
            aria-valuemin="0"
            aria-valuemax="100"
      >{{Math.round(calculatePercent(poll[1], total_votes))+'%'}}</div>
        </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapGetters } from 'vuex'
import { RTDB } from "../main.js";
export default {
  name: "ViewPoll",
  computed:{
    ...mapState(['code']),
    ...mapGetters(['getCode'])
  },
  data() {
    return {
      code_view:'',
      total_votes: 0,
      poll_question: "",
      poll_options: []
    };
  },
  methods: {
    calculatePercent (votes, total_votes) {
      if(total_votes===0){
        return 0;
      }
      else{
        return (100 * votes) / total_votes;
      }
    },
    calculateTotalVotes (poll_options) {
      poll_options.forEach((option) => {
        this.total_votes += option[1]
        })
    },
    filterOptions(options){
      options[0].answers;
    },
  },
  mounted () {
    RTDB.ref('polls/'+this.$store.getters.getCode+'/answers').on('value',snapshot=>this.poll_options.push(snapshot.val()));
    RTDB.ref('polls/'+this.$store.getters.getCode+'/question').on('value',snapshot=>this.poll_question=(snapshot.val()));
    //console.log(this.poll_options[0][Object.keys(this.poll_options[0])].question);
    this.calculateTotalVotes(this.poll_options[0]);
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
h4 {
  color: #4c4c4c;
  text-align: center;
}
.container{
  
  border: 1px solid #d0d0d0;
  background-color: #fff;
  padding-top: 40px;
  padding-bottom: 40px;
  border-radius: 5px;
  margin: 0 auto;
}

.progress-item{
  margin-top: 1rem;
  position: relative;
  width: 100%;
}

.progress{
  min-height: 2rem;
  height: auto;
  max-height: 5rem;
}

.progress-bar-striped{
  text-align: left;
}

.options-text{
  float: left;
  width: auto;
  min-width: 10rem;
  max-width: 10rem;
  min-height: 2rem;
  
}

</style>
